package com.qmth.ops.api.controller.admin;

import com.qmth.boot.api.annotation.Aac;
import com.qmth.boot.api.annotation.BOOL;
import com.qmth.boot.core.exception.ParameterException;
import com.qmth.ops.api.constants.OpsApiConstants;
import com.qmth.ops.api.dto.LoginResult;
import com.qmth.ops.api.security.AdminSession;
import com.qmth.ops.biz.domain.Role;
import com.qmth.ops.biz.domain.User;
import com.qmth.ops.biz.query.UserQuery;
import com.qmth.ops.biz.service.AppUserService;
import com.qmth.ops.biz.service.UserService;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

@RestController
@RequestMapping(OpsApiConstants.ADMIN_URI_PREFIX + "/user")
public class UserController {

    @Resource
    private UserService userService;

    @Resource
    private AppUserService appUserService;

    @PostMapping("/login")
    @Aac(auth = BOOL.FALSE)
    public LoginResult login(User request) {
        User user = userService.findByLoginName(request.getLoginName());
        if (user == null) {
            throw new ParameterException("登录名错误");
        }
        if (!user.buildPassword(request.getPassword()).equals(user.getPassword())) {
            throw new ParameterException("密码错误");
        }
        return new AdminSession(user, appUserService).getLoginResult();
    }

    @PostMapping("/query")
    public UserQuery query(@RequestAttribute AdminSession accessEntity, UserQuery query) {
        accessEntity.validateRole(Role.ADMIN);
        return userService.query(query);
    }
}
